package com.company.combobox.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.annotation.PostConstruct;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@JmixEntity
@Table(name = "MUSIC_CHOICE")
@Entity
public class MusicChoice {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "CATEGORY", nullable = false)
    @NotNull
    private Integer category;

    @Column(name = "RATING", nullable = false)
    @NotNull
    private Integer rating;

    @Column(name = "STYLE", nullable = false)
    @NotNull
    private Integer style;

    public Rating getRating() {
        return rating == null ? null : Rating.fromId(rating);
    }

    public void setRating(Rating rating) {
        this.rating = rating == null ? null : rating.getId();
    }

    public MusicStyle getStyle() {
        return style == null ? null : MusicStyle.fromId(style);
    }

    public void setStyle(MusicStyle style) {
        this.style = style == null ? null : style.getId();
    }

    public MusicStyleCategory getCategory() {
        return category == null ? null : MusicStyleCategory.fromId(category);
    }

    public void setCategory(MusicStyleCategory category) {
        this.category = category == null ? null : category.getId();
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }

    @PostConstruct
    public void postConstruct() {
        setCategory(MusicStyleCategory.ALL);
    }
}